<template>
    <div class="container mt-4 info">
        <div class="row">
            <div class="col-2">
                <div class="list-group" id="list-tab" role="tablist">
                    <a ref="profile" class="list-group-item list-group-item-action active" id="list-home-list" data-toggle="list" href="#list-home" role="tab" aria-controls="home">Thông tin cá nhân</a>
                    <a ref="order" class="list-group-item list-group-item-action" id="list-profile-list" data-toggle="list" href="#list-profile" role="tab" aria-controls="profile">Đơn hàng</a>
                    <a ref="address" class="list-group-item list-group-item-action" id="list-messages-list" data-toggle="list" href="#list-messages" role="tab" aria-controls="messages">Địa chỉ</a>
                    <a ref="password" class="list-group-item list-group-item-action" id="list-settings-list" data-toggle="list" href="#list-settings" role="tab" aria-controls="settings">Thay đổi mật khẩu</a>
                </div>
            </div>
            <div class="col-10">
                <div class="" id="nav-tabContent">
                    <div class="tab-pane fade show active" id="list-home" role="tabpanel" aria-labelledby="list-home-list">
                        <div class="row">
                        <!-- Basic Layout -->
                            <div class="col-xxl">
                                <div class="card mb-4">
                                <div class="card-header pb-0">
                                    <h4 class="mb-0">Hồ sơ của tôi</h4> <small class="text-muted">Quản lý thông tin hồ sơ để bảo mật tài khoản</small>
                                    <h5 v-if="updateSuccess" class="text-success">Cập nhật thông tin cá nhân thành công</h5>
                                    <hr>
                                </div>
                                <div class="card-body pt-1">
                                    <form>
                                        <div class="row mb-3">
                                            <label class="col-sm-2 col-form-label" for="basic-default-company">Tên</label>
                                            <div class="col-sm-10">
                                                <input type="text" class="form-control" v-model="profile.name" :disabled="!editProfile" />
                                                <span class="text-danger" v-if="errors?.name">{{ errors.name[0] }}</span>
                                            </div>
                                        </div>
                                        <div class="row mb-3">
                                            <label class="col-sm-2 col-form-label" for="basic-default-email">Email</label>
                                            <div class="col-sm-10">
                                                <input type="email" class="form-control" v-model="profile.email" :disabled="!editProfile" />
                                                <span class="text-danger" v-if="errors?.email">{{ errors.email[0] }}</span>
                                            </div>
                                        </div>
                                        <div class="row mb-3">
                                            <label class="col-sm-2 col-form-label" for="basic-default-phone">Số điện thoại</label>
                                            <div class="col-sm-10">
                                                <input type="text" class="form-control phone-mask" v-model="profile.phone" :disabled="!editProfile" />
                                                <span class="text-danger" v-if="errors?.phone">{{ errors.phone[0] }}</span>
                                            </div>
                                        </div>
                                        <div class="row justify-content-end">
                                            <div class="col-sm-10" v-if="!editProfile">
                                                <button type="button" v-on:click="editProfile = !editProfile" class="btn btn-primary">Chỉnh sửa</button>
                                            </div>
                                            <template v-else>
                                                <div class="col-sm-10">
                                                    <button type="button" v-on:click="editProfile = !editProfile" class="btn btn-danger">Huỷ</button>
                                                    <button type="button" v-on:click="saveProfile()" class="btn btn-primary mx-1">Lưu</button>
                                                </div>
                                            </template>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                        </div>
                    </div>
                    <div class="tab-pane fade" id="list-profile" role="tabpanel" aria-labelledby="list-profile-list">
                        <list-order>

                        </list-order>
                    </div>
                    <div class="tab-pane fade" id="list-messages" role="tabpanel" aria-labelledby="list-messages-list">
                        <info-address :user="user"></info-address>
                    </div>
                    <div class="tab-pane fade" id="list-settings" role="tabpanel" aria-labelledby="list-settings-list">
                        <div class="row">
                            <div class="col-xxl">
                                <div class="card mb-4">
                                    <div class="card-header pb-0">
                                        <h4 class="mb-0">Thay đổi mật khẩu</h4> <small class="text-muted">Vui lòng không cung cấp mật khẩu cho bất kỳ ai để bảo mật tài khoản</small>
                                        <h5 v-if="updateSuccess" class="text-success">Cập nhật mật khẩu thành công</h5>
                                        <hr>
                                    </div>
                                    <div class="card-body pt-1">
                                        <form>
                                            <div class="row mb-3">
                                                <label class="col-sm-2 col-form-label" for="basic-default-company">Mật khẩu cũ</label>
                                                <div class="col-sm-4 input-group" style="width: auto;">
                                                    <input :type="hide.typePassOld" v-model="updatePassword.passwordOld" class="form-control"  placeholder="Mật khẩu cũ" />
                                                    <span v-on:click="setType(1)" class="input-group-text cursor-pointer">
                                                        <i class="bx" :class="{'bx-hide': hide.typePassOld == 'password', 'bx-show': hide.typePassOld == 'text'}"></i>
                                                    </span>
                                                    <span class="text-danger" v-if="errorPassword?.passwordOld">{{ errorPassword.passwordOld[0] }}</span>
                                                    <span class="text-danger" v-if="passwordOldError">{{ passwordOldError }}</span>
                                                </div>
                                            </div>
                                            <div class="row mb-3">
                                                <label class="col-sm-2 col-form-label" for="basic-default-company">Mật khẩu mới</label>
                                                <div class="col-sm-4 input-group" style="width: auto;">
                                                    <input :type="hide.typePassNew" v-model="updatePassword.passwordNew" class="form-control"  placeholder="Mật khẩu mới"  />
                                                    <span v-on:click="setType(2)"  class="input-group-text cursor-pointer">
                                                        <i class="bx" :class="{'bx-hide': hide.typePassNew == 'password', 'bx-show': hide.typePassNew == 'text'}"></i>
                                                    </span>
                                                    <span class="text-danger" v-if="passwordNotConfirm">Mật khẩu không khớp</span>
                                                    <span class="text-danger" v-if="errorPassword?.passwordNew">{{ errorPassword.passwordNew[0] }}</span>
                                                </div>
                                            </div>
                                            <div class="row mb-3">
                                                <label class="col-sm-2 col-form-label" for="basic-default-company">Nhập lại mật khẩu mới</label>
                                                <div class="col-sm-4 input-group" style="width: auto;">
                                                    <input :type="hide.typePassComfirm" v-model="updatePassword.passwordComfirm" class="form-control"  placeholder="Nhập lại mật khẩu mới"  />
                                                    <span v-on:click="setType(3)" class="input-group-text cursor-pointer">
                                                        <i class="bx" :class="{'bx-hide': hide.typePassComfirm == 'password', 'bx-show': hide.typePassComfirm == 'text'}"></i>
                                                    </span>
                                                    <span class="text-danger" v-if="passwordNotConfirm">Mật khẩu không khớp</span>
                                                </div>
                                            </div>
                                            <div class="row justify-content-end">
                                                <div class="col-sm-10">
                                                    <button type="button" v-on:click="update()" class="btn btn-primary">Chỉnh sửa</button>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import ListOrderComponent from './child/ListOrderComponent.vue';
import AddressComponent from './child/AddressComponent.vue';
    export default {
        name: 'info',
        components:{
            'list-order': ListOrderComponent,
            'info-address' : AddressComponent
        },
        data(){
            return {
                tab: 10,
                profile: {},
                editProfile: false,
                errors: null,
                updateSuccess: false,
                updatePassword: {
                    passwordOld: '',
                    passwordNew: '',
                    passwordComfirm: ''
                },
                hide: {
                    typePassOld: 'password',
                    typePassNew: 'password',
                    typePassComfirm: 'password'
                },
                errorPassword: null,
                passwordOldError: null,
                passwordNotConfirm: false
            }
        },
        props:{
            user: {
                type: Object,
                required: true
            },
        },
        methods:{
            setType(num) {
                console.log(num);
                switch (num) {
                    case 3:
                        this.hide.typePassComfirm == 'text' ?  this.hide.typePassComfirm = 'password' : this.hide.typePassComfirm = 'text';
                        break;
                    case 2:
                        this.hide.typePassNew == 'text' ?  this.hide.typePassNew = 'password' : this.hide.typePassNew = 'text';
                        break;
                    case 1:
                        this.hide.typePassOld == 'text' ?  this.hide.typePassOld = 'password' : this.hide.typePassOld = 'text';
                        break;
                    default:
                        console.log('');
                        break;
                }
            },
            saveProfile(){
                this.$store.dispatch('updateUser', this.profile).then(res => {
                    this.updateSuccess = true;
                    this.editProfile = false;
                    setTimeout(() => {
                        this.updateSuccess = false;
                    }, 2000);
                }).catch(error => {
                    if (error.response.status === 422) {
                        this.errors = error.response.data.errors
                    }
                })
            },
            update(){
                this.passwordNotConfirm = false;
                this.passwordOldError = null;
                this.errorPassword = null;
                if(this.updatePassword.passwordNew != this.updatePassword.passwordComfirm) {
                    this.passwordNotConfirm = true;
                    this.updatePassword.passwordComfirm = '';
                    return;
                }
                this.$store.dispatch('changePsss', this.updatePassword).then(res => {
                    if(res.status === 200) {
                        this.updateSuccess = true;
                        setTimeout(() => {
                            this.updateSuccess = false;
                        }, 2000);
                        this.resetFormUpdatePass();
                    }
                    if(res.status === 1005) {
                        this.passwordOldError = 'Mật khẩu cũ không đúng';
                        this.resetFormUpdatePass();
                    }
                }).catch(error => {
                    if (error.response.status === 422) {
                        this.errorPassword = error.response.data.errors;
                        this.resetFormUpdatePass();
                    }
                })
            },
            resetFormUpdatePass(){
                this.updatePassword.passwordComfirm = '';
                this.updatePassword.passwordNew = '';
                this.updatePassword.passwordOld = '';
            }
        },
        mounted() {
            this.profile.name = this.user.name;
            this.profile.email = this.user.email;
            this.profile.phone = this.user.phone;
            let url = new URL(window.location.href);
            let param = url.searchParams.get("tab");
            
            switch (param) {
                case 'profile':
                    this.$refs.profile.click();
                    break;

                case 'order':
                    this.$refs.order.click();
                    break;
            
                default:
                    this.$refs.profile.click();
                    break;
            }
        }
    }
</script>
<style lang="scss">
.info{
    .list-group {
        background: #FFFFFF;
    }
    .list-group-item.active{
        background-color:transparent;
        color: red;
        border:1px solid #d9dee3;
    }
    .card-body {
        height: 100%;
        .col-form-label {
            text-transform: none;
            font-weight: 500;
            font-size: 0.875rem;
            text-align: end;
        }
    }
    .color-black {
        color: #333
    }
    .fade:not(.show) {
        display: none;
    }
    .color-status {
        color: rgb(50, 181, 180);
    }
    .list-status {
        padding: 0px 10px;
        background-color: #ffffff;
        border-radius: 4px;
        .nav-link {
            background-color: transparent !important;
        }
        .active {
            color: red !important;
            border-bottom: 2px solid red;
            background-color: transparent;
        }
    }
}
</style>